module test;
bit		clk;
semaphore	mutex;

initial begin
	mutex = new(1);
	
	fork
		proc("P1");
		proc("P2");
	join
end
	
initial forever #10 clk = ~clk;
initial #200 $finish;
	
task automatic proc(string name);
	forever begin
		mutex.get(1);
		$display("@%3t: %s got a key",$time,name);
		repeat( $random&3 ) @(posedge clk);
		mutex.put(1);
		$display("@%3t: %s released a key",$time,name);
	end
endtask

endmodule
