module test;
mailbox		fifo;
bit		clk;

initial begin
	fifo = new(5);
	fork
		consumer();
		producer();
	join
end

initial forever #10 clk = ~clk;
initial #200 $finish;

task producer();
int	delay, num_data;

	forever begin
		delay = $random&7;
		repeat( delay ) @(posedge clk);
		num_data = $urandom_range(1,5);
		$write("@%3t: put %0d data:",$time,num_data);
		for( int i = 0; i < num_data; i++ ) begin
			fifo.put($time+i);
			$write(" %0d",$time+i);
		end
		$display;
	end
endtask

task consumer();
int	data;

	forever begin
		fifo.get(data);
		$display("@%3t: got data %0d",$time,data);
	end
endtask

endmodule