module dut(input clk,reset,[3:0] d,output logic [3:0] q);

always @(posedge clk,posedge reset)
	if( reset == 1'b1 )
		q <= 0;
	else
		q <= d;

endmodule

checker monitor(input logic clk,reset,[3:0] d,q);

initial $display("       d  q");

always @(posedge clk)
	$display("@%3t: %2d %2d",$time,d,q);
always @(posedge reset)
	$display("@%3t: %2d %2d *RESET*",$time,d,q);
			
endchecker

module test;
bit		clk;
logic		reset;
logic [3:0]	d, q;

monitor MONITOR(.*);
dut DUT(.*);

initial begin
	reset = #1 1;		// reset DUT
	reset = #1 0;
	
	repeat( 8 ) begin
		@(negedge clk);
		d = $random&15;
	end
	@(negedge clk) $finish;
end

initial forever #10 clk = ~clk;
	
endmodule
