module dut(input logic clk,logic [3:0] d,output logic [3:0] q);

always @(posedge clk)
	q <= d;
	
always @(posedge clk)
	   #0 $display("@%3t: d=%2d q=%2d DUT",$time,d,q);

endmodule

program test(input logic clk,logic [3:0] q,output logic [3:0] d);

initial
	d = 0;

initial forever
	@(negedge clk) d <= $urandom&15;
	
initial forever
	@(posedge clk) $display("@%3t: d=%2d q=%2d TEST",$time,d,q);
endprogram

module top;
bit		clk;
bit [3:0]	d, q;

dut DUT(.*);
test TEST(.*);

initial forever #10 clk = ~clk;
initial #80 $finish;

endmodule
