module top;
bit		clk;
logic [1:0]	a, b, sum;
logic		co;

clocking cb @(posedge clk); endclocking
	
dut DUT(.*);

always @(posedge clk)
	random_value(a,b);

always @cb
	$display("@%3t: a=%0d b=%0d {co,sum}=%0d",$time,a,b,{co,sum});
	
initial
	$dumpfile("Vcd/top.vcd");
initial
	$dumpvars(0,top);

initial forever #10 clk = ~clk;
initial #100 $finish;
	
function void random_value(output logic [1:0] x,y);
logic [1:0]	v1, v2;
	assert( std::randomize(v1,v2) );
	x = v1;
	y = v2;
endfunction

endmodule

module dut(input logic [1:0] a,b,output logic co,[1:0] sum);
assign {co,sum} = a+b;
endmodule
