class sample_t;
rand bit [7:0]	a, b, c;
constraint C1 { a + b + c == 32; }
constraint C2 { (a < b) && (b < c);}

function void post_randomize;
	$display("a=%3d b=%3d c=%3d",a,b,c);
endfunction
endclass

module test;
sample_t	sample = new;

initial begin	
	$display("satisfy: (a + b + c == 32) && (a < b) && (b < c);");	
	for( int i = 0; i < 2; i++ ) begin
		assert( sample.randomize() );	
	end
	$display("no constraints");
	sample.constraint_mode(0);			// make C1 and C2 inactive
	for( int i = 0; i < 2; i++ ) begin
		assert( sample.randomize() );	
	end
	$display("satisfy: a + b + c == 32;");
	sample.C1.constraint_mode(1);			// make C1 active
	for( int i = 0; i < 2; i++ ) begin
		assert( sample.randomize() );	
	end
end
endmodule
