typedef struct { rand logic [2:0] a, b; }	operand_s;

class sample_t;
rand operand_s	operand;
endclass

module dut(input logic [2:0] a,b,
	output logic [2:0] ab_or,ab_and,ab_xor);

always @(a,b) begin
	ab_or = a | b;
	ab_and = a & b;
	ab_xor = a ^ b;
end
	
endmodule

module test;
sample_t	sample;
logic [2:0]	a, b, ab_or, ab_and, ab_xor;

dut DUT(.*);

initial begin
	sample = new;
	
	repeat( 8 ) begin
		#10 assert( sample.randomize() );
		a = sample.operand.a;
		b = sample.operand.b;
	end
end

initial forever @(a,b)
	#0 $display("@%2t: a=%b b=%b or=%b and=%b xor=%b",
		$time,a,b,ab_or,ab_and,ab_xor);
		 
endmodule
