class sample_t;
rand bit [7:0] array_size;
rand bit [7:0] array[];

constraint size_constraint { array.size == array_size; }
extern constraint setup_size;	// to be defined externally
extern function void print;
endclass

constraint sample_t::setup_size
{
	array_size inside {[1:8]};
}
		
function void sample_t::print;
	$write("array_size=%0d array.size=%0d:",
		array_size, array.size);
	foreach(array[i])
		$write(" %3d",array[i]);
	$display;
endfunction

module test;
sample_t	sample = new;
	
initial begin
	repeat (10) begin
		assert (sample.randomize() );
		sample.print();
	end
end
endmodule
