class sample_t;
rand int	a, b;
int			a_stat[4], b_stat[4];
constraint C
{
	a dist { 0 := 10, [1:3] := 20 };
	b dist { 0 :/ 20, [1:3] :/ 30 };
}
	
function void post_randomize();
	a_stat[a]++;
	b_stat[b]++;
endfunction

function void print_stat(int tries);
	foreach(a_stat[i])
		$display("a==%0d  %.3f",i,real'(a_stat[i])/tries);
	foreach(b_stat[i])
		$display("b==%0d  %.3f",i,real'(b_stat[i])/tries);
endfunction

endclass

module test;
sample_t	sample = new;
int		tries = 256;

initial begin
	repeat( tries ) begin
		assert( sample.randomize() );
	end
	sample.print_stat(tries);
end
endmodule
