typedef enum bit [1:0] { ZERO, SMALL, MEDIUM, LARGE }	size_e;

class sample_t;
rand byte unsigned	data;
rand size_e		size;

constraint C {
	solve size before data;
	size == ZERO -> data inside { [0:2] };
	size == SMALL -> data inside { [16:32] };
	size == MEDIUM -> data inside { [64:128] };
	size == LARGE -> data inside { [200:255] };
}
	
function void post_randomize();
	$display("size=%-6s data=%3d",size.name,data);
endfunction
endclass

module test;
sample_t	sample;

initial begin
	sample = new;
	repeat(12) begin
		assert( sample.randomize() );
	end
end
endmodule

