module dut(input logic [1:0] a,b,output co,[1:0] sum);
assign {co,sum} = a+b;
endmodule

module test;
logic [1:0]	a, b, sum, ta, tb;
logic		co;

covergroup cg_t;
	aBYb: cross a, b;
endgroup

dut DUT(.*);

initial begin
	cg_t	cg = new;
	
	repeat( 48 ) begin
		#10 assert( std::randomize(ta,tb) );
		a = ta;
		b = tb;
		cg.sample();
	end
end

initial forever @(a,b) #0 begin
	if( a+b+3'b0 != {co,sum} )
		$display("@%3t: %0d %0d %0d FAIL",$time,a,b,{co,sum});
	end
endmodule
