`include "pkg.sv"

module top;
import pkg::*;
logic	reset, a, out;
bit	clk;
bit [11:0]	seq = 12'b0110_0111_0000;
string		inputs, outputs;

clocking cb @(posedge clk); endclocking
pattern_detector_moore DUT(.*);

initial begin
	reset = 1; reset = #1 0;
	for( int i = $left(seq); i >= $right(seq); i-- ) begin
		 a = seq[i];
		 @(negedge clk);
	end 
	$finish;
end

initial forever @cb begin
	inputs = {inputs,$sformatf("%b",a)};
	outputs = {outputs,$sformatf("%b",out)};
end
initial forever #10 clk = ~clk;
final begin
	$display("--- pattern_detector_moore ---");
	$display("inputs:  %s",inputs);
	$display("outputs: %s",outputs);
end
	
endmodule
