`include "pkg.sv"

module pattern_detector_mealy import pkg::*;
	(input clk,reset,a,output logic out);
state_e		state, next_state;

always @(posedge clk,posedge reset)
	if( reset == 1'b1 )
		state <= S0;
	else
		state <= next_state;
	
always @(state,a) begin
	out = 0;
	case(state)
	S0: next_state = a == 0 ? S1 : S2;
	S1: begin
		out = a == 0 ? 1 : 0;
		next_state = a == 0 ? S1 : S2;
	    end
	S2: begin
		out = a == 1 ? 1 : 0;
		next_state = a == 1 ? S2 : S1;
	    end
	endcase	
end
endmodule