module test;
parameter SIZE=8;
bit		clk, reset;
logic [SIZE-1:0]	q;
logic [3:0]	bin;

clocking cb @(posedge clk); endclocking
clocking cbr @(posedge reset); endclocking
johnson_counter #(.NBITS(SIZE)) DUT(.*);

initial begin
	$display("      binary  johnson");
	bin = 0;
	reset = #5 1;	// @5 enable reset
	reset = #1 0;	// @6 disable reset
end

always @cb print;
always @cbr print(1);

initial forever #10 clk = ~clk;
initial #300 $finish;
	
function void print(bit rst=0);
	if( rst )
		bin = 0;
	else
		bin++;
	$display("@%3t: %b    %b%s",
		$time,bin,q,rst ? " *RESET*" : "");
endfunction
endmodule
