`include "pkg.sv"

module test;
import pkg::*;
parameter SIZE=4;
bit		clk;
logic		reset, c1, c0, left_in, right_in;
logic [SIZE-1:0]	data_in, q;

clocking cb @(posedge clk); endclocking
clocking cbr @(posedge reset); endclocking
universal_shift_register #(.NBITS(SIZE)) DUT(.*);

initial begin
	drive_dut();
	@cb $finish;
end
initial
	$display("     reset {c1,c0} left_in right_in data_in q");
initial forever #10 clk = ~clk;
always @cb print();
always @cbr print(1);
	
task drive_dut();
	fork
		#5	begin reset = 1; reset = #1 0; {c1,c0} = HOLD; end
		#20	begin {c1,c0} = LOAD; data_in = 4'b1010; data_in = #20 'x; end
		#40	begin {c1,c0} = SHIFT_LEFT; right_in = 1'bz; end
		#60	begin {c1,c0} = SHIFT_RIGHT; left_in = 1'b1; end
		#80	begin {c1,c0} = HOLD; end
	join
endtask

function void print(bit rst=0);
usr_e	op;
	if( !rst )
		$cast(op,{c1,c0});
		
	$display("@%2t: %b     %b      %b       %b        %b    %b %s",
		$time,reset,{c1,c0},left_in,right_in,data_in,q,
			rst ? "RESET" : op.name);
endfunction
	
endmodule
