`include "pkg.sv"

module universal_shift_register import pkg::*; #(NBITS=2)
		(input clk,reset,c1,c0,left_in,right_in,[NBITS-1:0] data_in,
		output logic [NBITS-1:0] q);

always @(posedge clk,posedge reset)
	if( reset == 1 )
		q <= 0;
	else
		case ({c1,c0})
		HOLD:		q <= q;
		SHIFT_LEFT:	q <= {q[NBITS-2:0],right_in};
		SHIFT_RIGHT:	q <= {left_in,q[NBITS-1:1]};
		LOAD:		q <= data_in;
		endcase
			
endmodule
