module gray_counter #(NBITS=2)
	(input clk,reset,output logic [NBITS-1:0] q);
logic [NBITS-1:0]	binary;

always @(posedge clk,posedge reset)
	if( reset == 1 )
		binary <= 0;
	else
		binary <= binary+1;

always @(binary) begin
	q[NBITS-1] = binary[NBITS-1];

	for( int i = NBITS-2; i >= 0; i-- )
		q[i] = binary[i+1] ^ binary[i];
end
	
endmodule
