module test;
parameter SIZE=8;
bit			clk;
logic			reset;
logic [SIZE-1:0]	q;

clocking cb @(posedge clk); endclocking
clocking cbr @(posedge reset); endclocking
ring_counter #(.NBITS(SIZE)) DUT(.*);

initial begin
	$display("      reset one-hot");
	#5	reset = 1; reset = #1 0;
end

always begin
	@cb print();
	if( q[SIZE-1] == 1'b1 )
		$finish;
end
always @cbr print(1);
initial forever #10 clk = ~clk;
	
function void print(bit rst=0);
	$display("@%3t: %b     %b%s",$time,reset,q,rst?" reset":"");
endfunction

endmodule
