`include "pkg.sv"

module test;
import pkg::*;
bit	clk, reset;
logic	a, parity;
logic [11:0] vector = 12'b1000_1000_1000;
string	inputs, checked;

clocking cb @(posedge clk); endclocking
parity_checker_moore DUT(.*);

initial begin
	reset = 1; reset = #1 0;
	for( int i = $left(vector); i >= $right(vector); i-- ) begin
		a = vector[i];
		@(negedge clk);
	end
	$finish;
end

initial forever @cb begin
	inputs = {inputs,$sformatf("%b",a)};
	checked = {checked,$sformatf("%b",parity)};
end
initial forever #10 clk = ~clk;
initial $dumpfile("Vcd/top.vcd");
initial $dumpvars(0,test);
final begin
	$display("--- parity_checker_moore ---");
	$display("inputs: %s",inputs);
	$display("parity: %s",checked);
end

endmodule
