`include "pkg_alu.sv"

module alu import pkg::*; #(NBITS=3)
	(input s2,s1,s0,[NBITS-1:0] a,b,output logic [NBITS-1:0] out);

always @(s2,s1,s0,a,b)
	case ({s2,s1,s0})
	CLEAR:	out = '0;
	PASS:	out = a;
	INV:	out = ~a;
	XOR:	out = a^b;
	OR:	out = a|b;
	AND:	out = a&b;
	NAND:	out = ~(a&b);
	SET:	out = '1;
	endcase
		
endmodule
