module test;
parameter	SIZE = 4;
bit			clk, up, pc, load;
logic [SIZE-1:0]	d, q, qn;

clocking cb @(posedge clk); endclocking
binary_counter #(.NBITS(SIZE)) DUT(.*,.ck(clk));

initial
	fork
		begin load = 1; d = 9; #15 load = 0; end
		begin #20 up = 1; #40 up = 0; end
		begin #100 pc = 1; #20 pc = 0; up = 1; end
	join
		
always @(cb)
	$display("@%3t: pc=%b load=%b up=%b d=%2d q=%2d(%b) qn=%2d(%b)",
		$time,pc,load,up,d,q,q,qn,qn);
			
initial forever #10 clk = ~clk;
initial #150 $finish;
endmodule
