`include "pkg.sv"

module test;
import pkg::*;
bit		clk;
logic	j, k, q, qbar;
jk_op_e	op;

clocking cb @(posedge clk); endclocking

jk_ff DUT(.*);

initial begin
	$display("     j  k  q  qbar  op");
	fork
		{j,k} = RESET;
		#20 {j,k} = HOLD;
		#40 {j,k} = SET;
		#60 {j,k} = TOGGLE;
	join_none
	
	forever begin
		@cb;
		$cast(op,{j,k});
		$display("@%2t: %b  %b  %b  %b     %s",$time,j,k,q,qbar,op.name);
	end
end

initial forever #10 clk = ~clk;
initial #100 $finish;
endmodule