module mux(input [3:0] a,b,logic s,output [3:0] out);
logic [3:0]	_out;

assign out = (s == 1'b0 || s == 1'b1) ? _out : 'x;

always @(a,b,s)
	if( s == 1'b0 )
		_out = a;
	else
		_out = b;
			
endmodule

/*
module mux(input [3:0] a,b,logic s,output logic [3:0] out);

always @(a,b,s)
	case (s)
	1'b0: out = a;
	1'b1: out = b;
	default: out = 'x;
	endcase
			
endmodule

*/

module test;
logic [3:0]	a, b, out, tmp;
logic		s;

mux DUT(.*);

	initial begin
		$display("     a b s out");
		a = 1;
		b = 2;
		repeat( 8 ) begin
			#10 tmp = $random&15;
			if( tmp > 7 )
				s = 1'bx;
			else
				s = tmp;
		end
	end
	
	initial forever @(s)
		#0 $display("@%2t: %0d %0d %b %0d",$time,a,b,s,out);
		
endmodule
