class base_transaction_t;			// base class

virtual function void print;			// virtual
	$display("base_transaction_t no members.");
endfunction

function void print_class;
	$display("base_transaction_t");		// non-virtual
endfunction
endclass

class transaction_t extends base_transaction_t;	// subclass
rand bit [15:0]	addr, data;

function new(bit [15:0] a=0,d=0);
	addr = a;
	data = d;
endfunction

function void print;
	$display("transaction_t has two members: addr=%0d data=%0d",
		addr,data);
endfunction

function void print_class;
	$display("transaction_t");
endfunction
endclass

module test;
base_transaction_t	base;
transaction_t		tr;

initial begin	
	base = new;
	tr = new(10,50);
	base.print;		// base_transaction_t::print
	base.print_class;	// base_transaction_t::print_class
	tr.print;		// transaction_t::print
	tr.print_class;		// transaction_t::print_class
	base = tr;
	base.print;		// transaction_t::print
	base.print_class;	// base_transaction_t::print_class	
end
endmodule
