class sample_t;
parameter	PI = 3.14;
typedef enum { RED, GREEN, YELLOW }	color_e;
static sample_t	head, tail;				// static properties
sample_t	next;
string	name;

function new(string name);
	this.name = name;
	add_list(this);
endfunction

extern static function void add_list(sample_t obj);	// static method
endclass

function void sample_t::add_list(sample_t obj);
	if( tail == null ) begin
		head = obj;
		tail = obj;
	end else begin
		tail.next = obj;
		tail = obj;
	end
	obj.next = null;
endfunction

module test;
sample_t::color_e	color;				// class scope operator
sample_t		sample;

initial begin
	color = sample_t::GREEN;			// class scope operator
	
	$display("PI=%g %s=%0d",
		sample_t::PI, color.name,color);	// class scope operator
		
	sample = new("C1");
	sample = new("C2");
	sample = new("C3");

	sample = sample_t::head;			// class scope operator
	while( sample != null ) begin
		$display("%s",sample.name);
		sample = sample.next;
	end
end
endmodule
