module dut(input logic [3:0] a,b,output co,[3:0] sum);
assign {co,sum} = a+b;
endmodule

class sample_t;
rand logic [3:0]	a, b;
constraint C { a < b; }
endclass

module test;
sample_t	sample;
logic [3:0]	a, b, sum;
logic		co;

dut DUT(.*);

initial begin
	sample = new;
	repeat( 5 ) begin
		#10;
		assert( sample.randomize() );
		a = sample.a;
		b = sample.b;
	end
end

initial $display("      a  b  {co,sum}");
initial forever @(a,b)
	#0 $display("@%2t: %2d %2d   %2d",$time,a,b,{co,sum});
		
endmodule
