interface class storage_if#(type DT=int);
pure virtual function void put(DT a);
pure virtual function DT get();
pure virtual function int exists();
endclass

class list_t#(type T=int) implements storage_if#(T);	// implements
T	q[$];

virtual function void put(T a);		// implementation of put
	q.push_front(a);
endfunction

virtual function T get();			// implementation of get
	return q.pop_back();
endfunction

virtual function int exists();		// implementation of exists
	exists = q.size()>0;
endfunction
endclass

module test;
list_t#(string)	list;

initial begin
	list = new;
	
	list.put("Sunday");
	list.put("Monday");
	list.put("Tuesday");
	
	while( list.exists() ) begin
		$display("%s",list.get());
	end
end
	
endmodule
