class sample_base_t;
rand logic [15:0]	addr;
rand logic [31:0]	data;

virtual function string sprint();
	return $sformatf("addr=%h data=%0d",addr,data);
endfunction
endclass

class simple_sample_t extends sample_base_t;
	constraint C_ADDR { addr[1:0] == 2'b00; }
	constraint C_DATA { data inside { [0:2048] }; }
endclass

module test;
sample_base_t	base_sample;
simple_sample_t	sub_sample;

initial begin
	base_sample = new;
	sub_sample = new;
	assert( base_sample.randomize() );
	assert( sub_sample.randomize() );
	$display("%s: %s","base_sample",base_sample.sprint());
	$display("%s: %s","sub_sample",sub_sample.sprint());
end
	
endmodule
