module adder (sum_out, carry_out, carry_in, ina, inb);
output [3:0] 	sum_out;
output 		carry_out;
input [3:0] 	ina, inb;
input 		carry_in;
wire 		carry_out, carry_in;
wire [3:0] 	sum_out, ina, inb;

assign {carry_out,sum_out} = ina + inb + carry_in;

endmodule

module test;
logic		carry_out, carry_in;
logic [3:0]	ina, inb, sum_out;

adder DUT(.*);

initial begin
	$display("     carry_in ina inb {carry_out,sum_out}");
	repeat( 8 ) begin
		#10;
		carry_in = $random&1;
		ina = $random&15;
		inb = $random&15;
	end
end

initial forever @(ina,inb,carry_in)
	#0 $display("@%3t:    %0d    %2d  %2d    %2d",
		$time,carry_in,ina,inb,{carry_out,sum_out});

endmodule
