module one_of(input clk,s,a,b,output logic q);

always @(posedge clk)
	if( s == 1'b0 )
		q <= a;
	else
		q <= b;
			
endmodule

module test;
logic [15:0]	val;
logic	a, b, s, q;
bit		clk;

clocking cb @(posedge clk); endclocking
one_of DUT(.*);

initial begin
	repeat( 5 ) begin
		@(negedge clk);
		val = $random;
		s = ^val;
		a = val[0];
		b = ~a;
	end
	@(negedge clk) $finish;
end

initial forever #10 clk = ~clk;
initial $display("      a b  s q");
initial forever @cb
			$display("@%3t: %b %b  %b %b",$time,a,b,s,q);
				
endmodule
