module test;
logic		clk, reset, read, write, stack_empty, stack_full;
logic [2:0]	read_ptr,
		write_ptr;
logic [3:0]	ptr_diff;
logic [11:0]	stack[7:0];

logic [11:0]	data_in,
		data_out;
		
always @(posedge clk or posedge reset) begin
	if( reset )
		data_out <= 0;
	else if( read && !write && !stack_empty )
		data_out <= stack[read_ptr];
	else if( write && !read && !stack_full )
		stack[write_ptr] <= data_in;
end

// ...

endmodule